.CT
User's Guide
.LP
The compiler comes as a single executable file, named tcc.  The
easiest way to invoke the compiler is with the following command:
.DS
\f(CWtcc file.c
.DE
.LP
This will read ``file.c'' run it through the C preprocessor, compile
it and, assuming there were no errors, leave the assembly language
output in a file named ``file.s''  This is most easily assembled and
linked using the front end for the system compiler, using the
following command:
.DS
\f(CWcc file.s
.DE
.LP
Alternatively, tcc can compile its standard input and send the
assembly language output to its standard output; thus, it can be used
in a pipeline.  To accomplish this, no file name is given.  The C
preprocessor is not invoked in this case.  If it is desired
that tcc compile from its standard input to an output file, then the
output file can be specified with the ``-o'' option; this also overrides
the default output file name in the other case.  Use of the C
preprocessor can only be used when using a named file and
can be specifically overridden with the ``-n'' option, and
compiling to the standard output can be enforced with the ``-c'' option.
Therefore, all combinations of standard and file input/output are
possible.  The C preprocessor must be invoked separately if any
options need to be given to it.
.KS
.LP
Finally, tcc has an option to insert a flag into its output which
gives a permanent record that the file has been compiled with tcc.
This is the ``-i'' option.  When it is used, a line of the following
form is inserted into the output:
.DS
\f(CW.ascii  "@(#) tcc compiled: file.c@(#)"
.DE
.KE
.KS
.LP
When this is assembled and linked, the flag line can always be found
by examining the object file with the SCCS ``what'' command.  Finally,
tcc has a ``-h'' option; this gives the following help message:
.DS
\f(CWusage: tcc [-n] [-i] [-c] [-o filename] filename
		-n             don't use c preprocessor (only for files)
		-c             send output to standard out
		-i             add version type to output
		-o filename    place output into filename
.DE
.KE
.KS
.CT
Where to find tcc Online
.LP
The source code and executable for tcc, as well as as number of tests,
have been made available on machine ``lion''  They should be publicly
readable.  The directory paths are as follows:
.sp
.TS
l l.
lion:~mwandel/tcc/tcc	- Executable for the compiler
lion:~mwandel/tcc/src	- Source code for the compiler
lion:~mwandel/tcc/test	- Test cases
.TE
.KE
.sp
.LP
To test recompilation of the compiler with itself, one need only copy
the entire tcc directory tree somewhere where one has write access, go
into the tcc/src directory, remove the ``.s'' and ``.o'' files, and type
``make''
