#include "def.h"
#include "nodes.h"
static char *sccsid = "@(#) killtree.c 1.23@(#)";

/*
 *  Destroy a parse tree rooted at a given node.  All type chains and strings
 *  attached to the tree nodes are also freed.
 */
void kill_tree(node)
register struct treenode *node;
{
	void print_tree();
	if(node == 0 ) return;

	if(node->vtype) freetype(node->vtype);

	switch(node->format) {
		case NF_INNER:
			kill_tree(node->link1);
			kill_tree(node->link2);
			kill_tree(node->link3);
			break;
		case NF_LEAF_STRING:
			free(node->v_str);
			break;
		case NF_LEAF_STRCONST:
			free(node->v_strconst);
			break;
		case NF_LEAF_LABEL:
			free(node->v_name);
			break;
		case NF_INNER_DOT:
			kill_tree(node->v_dot_link);
	}
	free(node);
}
