/* @(#) symtab.h 1.24@(#) */

/*
 *  This header file defines symbol table entries.  The following structure
 *  is used for each.
 */
struct symbol {
   struct symbol *next;
   union {
		struct symbol *auxlink;
		struct treenode *nodeptr;
   } su;
   short         blocklevel;
   char          storclass;
   char          entrytype;
   struct type   *type;
   long          offset;
   char          name[1];
};

/*
 *  Functions which deal with symbol table entries.
 */
void init_symtab();
struct symbol *find_sym(/*char *,int,int*/);
struct symbol *make_sym(/*int,char *,int*/);
void delete_sym_level(/*int*/);

/*
 *  Entry types.  Note that these are all powers of two so more than one can
 *  be given in the form of a bit mask.
 */
#define ET_GLOBAL		1
#define ET_TYPEDEF		2
#define ET_STRUCTDEF	4
#define ET_ENUMDEF		8
#define ET_LOCAL		16
#define ET_ARGUMENT		32
#define ET_STATIC		64
#define ET_GOTOLABEL	128
