#include "def.h"
#include "types.h"
#include "nodes.h"
#include "nodetypes.h"
#include "error.h"
static char *sccsid = "@(#) typecheck3.c 1.7@(#)";

extern struct type *make_sign();
extern struct treenode *make_bit32();

	/*
	 * typechecking of conditional operators
	 *
	 * ALWAYS return a type of int
	 */

struct treenode *check_cond(type,l1,l2,l3)
int type;
struct treenode *l1, *l2, *l3;
{
	extern struct type *make_int();
	struct type *t1, *t2, *t3;
	struct treenode *tmp, *node = check_const(type,l1,l2,l3);

	/*
	 * a node is created with the call to check_const
	 * (if format has been changed, no more work needs to be done)
	 */

	if( node->format == NF_LEAF_CONST ) return node;

	/* add int return type to node */
	
	node->vtype = make_int();

	if( type == TN_LOGICNOT ) {
		node->link1 = make_bit32(node->link1);
		return node;
	}

	/* from now on we are working on two operand conditionals */

	node->link1 = l1 = make_bit32(node->link1);
	node->link2 = l2 = make_bit32(node->link2);

	t1 = skiprefnodes( l1->vtype );
	t2 = skiprefnodes( l2->vtype );

	switch( CROSS(t1->type,t2->type,8) ) {
		case CROSS(TT_BASICTYPE,TT_POINTERTO,8):
			tmp = l1; l1 = l2; l2 = tmp;
			tmp = node->link1; node->link1 = node->link2; node->link2 = tmp;
			t3 = t2; t2 = t1; t1 = t3;
		case CROSS(TT_POINTERTO,TT_BASICTYPE,8):
			if( type != TN_EQUAL && type != TN_NOTEQUAL ) {
				err(INVALIDPOINTEREXPR);
				kill_tree(node);
				freetype(t3);
				return make_const(1,1,1);
			} else if( l2->format != NF_LEAF_CONST && l2->v_sval != 0 ) {
				err(INVALIDPOINTEREXPR);
				kill_tree(node);
				freetype(t3);
				return make_const(1,1,1);
			}
			break;

		case CROSS(TT_BASICTYPE,TT_BASICTYPE,8):
		case CROSS(TT_ENUMHEADER,TT_BASICTYPE,8):
		case CROSS(TT_BASICTYPE,TT_ENUMHEADER,8):
		case CROSS(TT_ENUMHEADER,TT_ENUMHEADER,8):
			break;

		case CROSS(TT_POINTERTO,TT_POINTERTO,8):
			if(pointermatch(t1,t2)) break;
		default:
			err(INCOMPTYPES,node);
	}
	return node;
}
