#include "def.h"
static char *sccsid = "@(#) util.c 1.22@(#)";

/*
 *  Safely allocate memory.  This function does not return if memory cannot
 *  be allocated for any reason.
 */
void *safealloc(size)
unsigned size;
{
   void *p = malloc(size);
   if(!p) panic("out of memory");
   return p;
}

/*
 *  Print a fatal error message and exit.  Used for unrecoverable error
 *  situations.
 */
panic(str)
char *str;
{
   fprintf(stderr,"\n*** Fatal error: %s.\n",str);
   exit(99);
}

/*
 *  Clone a string and return a pointer to "own" copy.
 */
char *save_str( str )
char *str;
{
	char *new;
	int len;

	len = strlen( str );
	new = (char*) safealloc( len + 1 );
	strcpy( new, str);
	return new;
}
